<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-field.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-filter.html">
<link rel="import" href="../bower_components/brum-global-variable/brum-global-variable.html">
<link rel="import" href="shared-styles.html">

<dom-module id="matches-list">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
        background: transparent;
      }
      vaadin-grid-filter {
        width: 100%;
      }
      vaadin-text-field {
        width: 100%;
      }
    </style>

    <brum-global-variable key="apiBase" value="{{apiBase}}" readonly></brum-global-variable>
    <brum-global-variable key="backendBase" value="{{backendBase}}" readonly></brum-global-variable>
    <brum-global-variable key="teamAuth" value="{{teamAuth}}" readonly></brum-global-variable>

    <iron-ajax with-credentials auto url="[[apiBase]]/matches" last-response="{{matches}}"></iron-ajax>

    <div class="card">
      <vaadin-grid items="[[matches.result]]">
        <vaadin-grid-column>
          <template class="header">Date</template>
          <template>[[item.date]]</template>
        </vaadin-grid-column>

        <template is="dom-if" if="[[!teamAuth]]">
          <vaadin-grid-column>
            <template class="header">
              <vaadin-grid-filter path="teams.0.team" value="[[_filterFirstTeam]]">
                <vaadin-text-field slot="filter" placeholder="First team" value="{{_filterFirstTeam}}"
                                   focus-target></vaadin-text-field>
              </vaadin-grid-filter>
            </template>
            <template>[[item.teams.0.team]]</template>
          </vaadin-grid-column>
          <vaadin-grid-column>
            <template class="header">Points</template>
            <template>[[item.teams.0.points]]</template>
          </vaadin-grid-column>

          <vaadin-grid-column>
            <template class="header">
              <vaadin-grid-filter path="teams.1.team" value="[[_filterSecondTeam]]">
                <vaadin-text-field slot="filter" placeholder="Second team" value="{{_filterSecondTeam}}"
                                   focus-target></vaadin-text-field>
              </vaadin-grid-filter>
            </template>
            <template>[[item.teams.1.team]]</template>
          </vaadin-grid-column>
          <vaadin-grid-column>
            <template class="header">Points</template>
            <template>[[item.teams.1.points]]</template>
          </vaadin-grid-column>
        </template>
        <template is="dom-if" if="[[teamAuth]]">
          <vaadin-grid-column>
            <template class="header">Our points</template>
            <template>[[item.teams.me.points]]</template>
          </vaadin-grid-column>

          <vaadin-grid-column>
            <template class="header">
              <vaadin-grid-filter path="teams.opponent.team" value="[[_filterSecondTeam]]">
                <vaadin-text-field slot="filter" placeholder="Opponent" value="{{_filterSecondTeam}}"
                                   focus-target></vaadin-text-field>
              </vaadin-grid-filter>
            </template>
            <template>[[item.teams.opponent.team]]</template>
          </vaadin-grid-column>
          <vaadin-grid-column>
            <template class="header">Opponent points</template>
            <template>[[item.teams.opponent.points]]</template>
          </vaadin-grid-column>
        </template>

        <vaadin-grid-column>
          <template class="header">Status</template>
          <template>[[item.status]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">Container</template>
          <template>
            <a href="[[backendBase]]/containers/[[item.containerId]]/logs">Logs</a>
          </template>
        </vaadin-grid-column>
      </vaadin-grid>
    </div>
  </template>
  <script>
    class MatchesList extends Polymer.Element {
      static get is() {
        return 'matches-list';
      }

      // noinspection JSUnusedGlobalSymbols
      static get properties() {
        return {
          _filterFirstTeam: {
            type: String,
            value: '',
          },
          _filterSecondTeam: {
            type: String,
            value: '',
          },
        };
      }
    }

    window.customElements.define(MatchesList.is, MatchesList);
  </script>
</dom-module>
